
/******************************************************************
 *                                                                *
 *                  Computer Science Department                   *
 *                                                                *
 *                        Master's Project                        *
 *                                                                *
 *                Graphical Development Environment               *
 *                                                                *
 *                     for Postgres Database                      *
 *                                                                *
 *                    Designed Especially for                     *
 *                                                                *
 *                 Postgres Developers and Users                  *
 *                                                                *
 *                              At                                *
 *                                                                *
 *                     Concordia University                       *
 *                                                                *
 ******************************************************************
 *                                                                *
 * Designer and Programmer:  Khaled Jababo                        *
 * Email                  :  jababo@cs.concordia.ca               *
 *                                                                *
 * Supervised by          :  Dr. Bipin C. Desai.                  *
 *                           Computer Science Department.         *
 * Email                  :  bcdesai@cs.concordia.ca              *
 *                                                                *
 * Last Modified          :  June 18, 1994                        *
 *                                                                *
 *                                                                *
 *                                                                *
 * Disclaimer:  There are no guarantees as to the accuracy, cu-   *
 *             rrency, quality, or usefulness of these programs   *
 *             or any information that is provided by using it.   *
 *             Furthermore, there is no assumption of responsi-   *
 *             bility for any los or damage which may be caused   *
 *             by their use.                                      *
 *                                                                *
 *                                                                *
 * Forward comments or questions about this report or the GDEP    *
 * system to:                                                     *
 *              bcdesai@cs.concordia.ca                           *
 *              jababo@cs.concordia.ca                            *
 *                                                                *
 ******************************************************************/


/******************************************************************/
/***********************     xahandle.c    ************************/
/******************************************************************/
/*                                                                */
/*    This File Contains all the functions  needed to respond to  */
/*  the events that the progrm has to take care of in xaevents.c  */
/*  file.                                                         */
/*                                                                */
/******************************************************************/

#include "mainfile.h"


XmString    XaString[20] ;

/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*        PullDown Application Main Menubar Handler Events       */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                         XaFhandleLoad                         */
/*    Function to Handle The Event  of Load that  appears in the */
/*  submenu of Application in main menu bar.  It Loads the Data- */
/*  base requested by the user.                                  */
/*                                                               */
/*****************************************************************/

void XaFhandleLoad(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleLoad function */

    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData = MaFgetPtrClientData() ;

    XaFsetWorkingCursorFont () ;

    MaLpClientData -> MaLstringList =  
              MaFgetStringListExePqCommand("retrieve (pg_database.datname)") ;

    strcpy(MaLpClientData -> MaLlistLabel, "Database List:") ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionSetDataBase ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont () ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;
  } /* end   XaFhandleLoad function */


/*****************************************************************/
/*                      XaFhandleSetRootClass                    */
/*    Function to Handle The Event  of Set Root Class that exist */
/*  in submenu Application of the main menubar. It sets the root */
/*  class that the user wishes to do queries on.                 */
/*                                                               */
/*****************************************************************/

void XaFhandleSetRootClass(XaLwidget)
  Widget XaLwidget ;

  { /* begin XaFhandleSetRootClass function */

    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaDbName,"Database Name is Empty"))
        return ;

    XaFsetWorkingCursorFont () ;

    MaLpClientData = MaFgetPtrClientData() ;

    MaLpClientData -> MaLstringList =  
                        MaFgetStringListExePqCommand("retrieve \
       (pg_class.relname) where pg_class.relname !~ \"pg_.*\"" ) ;

    strcpy(MaLpClientData -> MaLlistLabel, "Class List:") ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionSetClass ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont () ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;
    
  } /* end   XaFhandleSetRootClass function */


/*****************************************************************/
/*                         XaFhandleCreate                       */
/*    Function to Handle The Event of Create that appears in the */
/*  submenu of Application in main menu bar.                     */
/*                                                               */
/*****************************************************************/

void XaFhandleCreate(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleCreate function */

    if (XaSystemAdministratorPrivilege == MaFALSE)
      {
        if (XaFisEmptyString(XaLwidget,"",
            "WARNING Only SYSTEM ADMINISTRATOR can create a new Database"))
          return ;
      }
    else
      {
        extern MaStringListStruct MaFgetStringListExePqCommand() ;
        extern MaClientDataStruct MaFgetPtrClientData() ;

        MaClientDataStruct MaLpClientData = MaFgetPtrClientData() ;

        XaFsetWorkingCursorFont () ;

        MaLpClientData -> MaLstringList =  
              MaFgetStringListExePqCommand("retrieve (pg_database.datname)") ;

        strcpy(MaLpClientData -> MaLlistLabel, "Database List:") ;

        MaLpClientData -> MaLselectionAction = MaSelectionActionCreateDataBase ;
        MaLpClientData -> MaLselectionMode   = MaSelectionMustNotMatch ;

        XaFsetRegularCursorFont () ;

        XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;
      }

  } /* end   XaFhandleCreate function */


/*****************************************************************/
/*                          XaFhandleQuit                        */
/*    Function to Handle The Event  of Quit that  appears in the */
/*  submenu of Application in main menu bar.                     */
/*                                                               */
/*****************************************************************/

void XaFhandleQuit(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleQuit function */

    XaFsetWorkingCursorFont () ;
    MaFendUp() ;
    XaFsetRegularCursorFont () ;

    exit() ;

  } /* end   XaFhandleQuit function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*           PullDown Edit Main Menubar Handler Events           */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                    XaFhandleEditCreateNewClass                */
/*    Function to Handle The Event of Create New Class that app- */
/*  ears in the submenu of Edit in main menu bar.                */
/*                                                               */
/*****************************************************************/

void XaFhandleEditCreateNewClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditCreateNewClass function */

    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;
    extern MaStringListStruct MaFpointerStringToListAdd() ;

    MaClientDataStruct MaLpClientData ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    sprintf(XaLquery,"retrieve (pg_class.relname)\
                      where pg_class.relname !~ \"pg_.*\"" ) ;

    MaLpClientData -> MaLstringList = MaFgetStringListExePqCommand(XaLquery) ;

    strcpy(MaLpClientData -> MaLlistLabel, 
            "Enter New Class Name to be added") ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionCreateNewClass ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustNotMatch ;

    if (MaLpClientData -> MaLstringList == NULL)
      MaLpClientData -> MaLstringList =
               MaFpointerStringToListAdd("No Classes In Current Database",
                                         MaLpClientData -> MaLstringList) ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleEditCreateNewClass function */


/*****************************************************************/
/*                  XaFhandleEditDestroyRootClass                */
/*    Function to Handle  The Event of Destroy Root class that   */
/*  appears in the submenu of Edit in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleEditDestroyRootClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditDestroyRootClass function */

    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    strcpy(MaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLquery,"retrieve (child=hijo.relname) \
                      from  clase, hijo in pg_class, hereda in pg_inherits \
                      where hereda.inhparent = clase.oid \
                            and hereda.inhrel = hijo.oid \
                            and clase.relname =  \"%s\"",
            MaLpClientData -> MaLclassName) ;

    MaLpClientData -> MaLstringList = MaFgetStringListExePqCommand(XaLquery) ;

    if (MaLpClientData -> MaLstringList == NULL)
      {
        sprintf(MaLpClientData -> MaLdialogMessage,
                "Are you sure you want to destroy Class %s",
                MaLpClientData -> MaLclassName) ;

        MaLpClientData -> MaLselectionMode = MaSelectionActionDestroyRootClass ;

        XaFsetRegularCursorFont() ;

        XaFconfirmUserRequestDialog(XaLwidget, MaLpClientData) ;
      }
    else
      {

        sprintf(MaLpClientData -> MaLdialogMessage,
                "Class %s Could not be Destroyed because it has Children Classes.",
                MaLpClientData -> MaLclassName) ;
        MaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;
        XaFsetRegularCursorFont() ;
        (void) XaFpostDialog(XtParent(XtParent(XaLwidget)), MaLpClientData) ;
      }

  } /* end   XaFhandleEditDestroyRootClass function */


/*****************************************************************/
/*                  XaFhandleEditAddNewChildClass                */
/*    Function to Handle  The Event of Add New  Child to a class */
/*  that appears in the submenu of Edit in main menu bar.        */
/*                                                               */
/*****************************************************************/

void XaFhandleEditAddNewChildClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditAddNewChildClass function */

    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    strcpy(MaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLquery,"retrieve (pg_class.relname)\
                      where pg_class.relname !~ \"pg_.*\"" ) ;

    MaLpClientData -> MaLstringList = MaFgetStringListExePqCommand(XaLquery) ;

    sprintf(MaLpClientData -> MaLlistLabel, 
            "Enter New Child Name For Class %s",MaClassName) ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionAddNewChild ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustNotMatch ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleEditAddNewChildClass function */


/*****************************************************************/
/*                   XaFhandleEditAddAttributeClass              */
/*    Function to Handle The Event  of  Add Attribute Class that */
/*   appears in the submenu of Edit in main menu bar.            */
/*                                                               */
/*****************************************************************/

void XaFhandleEditAddAttributeClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditAddAttributeClass function */

    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    strcpy(MaLpClientData -> MaLclassName, MaClassName) ;

    /**************************************************/
    /*  Retrieve the Class Attributes and their types */
    /**************************************************/
    if (!XaFsetClassAttributeNameType(XaLwidget, MaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }
    {
      MaStringListStruct XaLtempPointer ;
      extern MaStringListStruct MaFpointerNodeToListAdd() ;

      MaLpClientData -> MaLstringList = 
                MaFpointerNodeToListAdd(MaLpClientData -> MaLstringList,
                                        MaLpClientData -> MaLtextStringList) ;

      XaLtempPointer = MaLpClientData -> MaLstringList ;

      while (XaLtempPointer != NULL)
        {
          strcpy(XaLtempPointer -> MaLstringData, XaLtempPointer -> MaLlabelName) ;
          XaLtempPointer = XaLtempPointer -> MaLpNextString ;
        }
    }
    sprintf(MaLpClientData -> MaLlistLabel, 
            "Enter New Attribute Name For Class %s",MaLpClientData -> MaLclassName) ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionAddAttributeName ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustNotMatch ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleEditAddAttributeClass function */


/*****************************************************************/
/*                     XaFhandleAddInstanceClass                 */
/*    Function to Handle The Event  of Edit Instance Class That  */
/*  appears in the submenu of Edit in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleAddInstanceClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleAddInstanceClass function */
    MaClientDataStruct extern MaFgetPtrClientData() ;
    MaClientDataStruct XaLpClientData     ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name Is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLlistLabel, "Add Instance Class") ;
    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;


    /**************************************************/
    /*  Retrieve the Class Attributes and their types */
    /**************************************************/
    if (!XaFsetClassAttributeNameType(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }

    /**************************************************/
    /**************************************************/
    XaLpClientData -> MaLselectionAction = MaSelectionActionAddInstance ;
    XaLpClientData -> MaLeditableMode    = True ;

    XaFsetRegularCursorFont() ;

    XaFinstanceDisplayShell(XaLwidget, XaLpClientData) ;

  } /* end   XaFhandleAddInstanceClass function */


/*****************************************************************/
/*                     XaFhandleEditInstanceClass                */
/*    Function to Handle The Event  of Edit Instance Class That  */
/*  appears in the submenu of Edit in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleEditInstanceClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditInstanceClass function */
    MaClientDataStruct extern MaFgetPtrClientData() ;
    MaClientDataStruct XaLpClientData     ;
                       
    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name Is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLlistLabel, "Edit Instance Class") ;
    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;


    /**************************************************/
    /*  Retrieve the Class Attributes and their types */
    /**************************************************/
    if (!XaFsetClassAttributeNameType(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }

    /***************************************************/
    /*  Retrieve the oid of the Instances of the Class */
    /* and set the previous, current and next Oids.    */
    /***************************************************/
    if (!XaFsetClassObjectIdsInstances(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }


    /***************************************************/
    /***************************************************/
    XaLpClientData -> MaLselectionAction = MaSelectionActionEditInstance ;
    XaLpClientData -> MaLeditableMode    = True ;

    XaFsetRegularCursorFont() ;

    XaFinstanceDisplayShell(XaLwidget, XaLpClientData) ;

  } /* end   XaFhandleEditInstanceClass function */


/*****************************************************************/
/*                  XaFhandleEditChangeParentClass               */
/*    Function to Handle  The Event  of Change Parent Class that */
/*  appears in the submenu of Edit in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleEditChangeParentClass(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleEditChangeParentClass function */
    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetAllCildrenList() ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaStringListStruct MaFexcludeNodeList1FromList2() ;
    extern MaStringListStruct MaFfreeStringList () ;
    extern MaStringListStruct MaFpointerStringToListAdd() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaStringListStruct MaLallClassesList ;
    MaStringListStruct MaLchildrenList   ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    strcpy(MaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(MaLpClientData -> MaLexportFilename,"%s%s%s",
                                    MaProjectPath, 
                                    MaLpClientData -> MaLclassName,
                                    MaClassChangeParentExt) ;


    /***********************************************************************/
    /*  Open Change Parents Class Tree file to write Classes definition &  */
    /*  instances to it.                                                   */
    /***********************************************************************/
    if ((MaLpClientData -> MaLstreamExportFile =
                fopen(MaLpClientData -> MaLexportFilename, "w")) == NULL)
      {
        sprintf(MaLpClientData -> MaLdialogMessage, 
               "Unable to Open Class Data %s",
               MaLpClientData -> MaLexportFilename) ;

        MaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;

        XaFsetRegularCursorFont() ;

        XaFpostDialog(XtParent(XaLwidget) ,MaLpClientData) ;
        return ;
      }


    /***********************************************************************/
    /*  Create the List of Classes that are not subclasses of root Class   */
    /*  to avoid having circularity in the Database.                        */
    /***********************************************************************/
    MaLallClassesList = MaFgetStringListExePqCommand("retrieve \
       (pg_class.relname) where pg_class.relname !~ \"pg_.*\"" ) ;

    MaLchildrenList = MaFgetAllCildrenList(MaLpClientData -> MaLclassName) ;
    MaLchildrenList = MaFpointerStringToListAdd(MaLpClientData -> MaLclassName,
                                                MaLchildrenList) ;

    MaLpClientData -> MaLstringList = MaFexcludeNodeList1FromList2(MaLchildrenList,
                                                                   MaLallClassesList) ;
    MaLpClientData -> MaLchildrenStringList = MaLchildrenList ;

    sprintf(MaLpClientData -> MaLlistLabel, "New Parents List For Class %s",
            MaLpClientData -> MaLclassName) ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionChangeParentClass ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleEditChangeParentClass function */


/*****************************************************************/
/*                         XaFhandleHelpEdit                     */
/*    Function to Handle The Event  of Help that  appears in the */
/*  submenu of Edit in main menu bar.                            */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpEdit(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpEdit function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueEdit) ;

  } /* end   XaFhandleHelpEdit function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*           PullDown View Main Menubar Handler Events           */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                    XaFhandleViewClassDescription              */
/*    Function to Handle The Event of View Class Descriptionthat */
/*  appears in the submenu of View in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleViewClassDescription(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleViewClassDescription function */
    MaClientDataStruct extern MaFgetPtrClientData() ;
    MaClientDataStruct XaLpClientData     ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLlistLabel, "View Class Definition") ;
    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;


    /**************************************************/
    /*  Retrieve the Class Attributes and their types */
    /**************************************************/
    if (!XaFsetClassAttributeNameType(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }

    /*********************************************************/
    /*  Set the Attribute type as the value of the attribute */
    /*********************************************************/
    {
      extern MaStringListStruct MaFpointerNodeToListAdd() ;
      XaLpClientData -> MaLstringList = MaFpointerNodeToListAdd(
                                           XaLpClientData -> MaLtextStringList,
                                           XaLpClientData -> MaLstringList) ;
      XaLpClientData -> MaLtextStringList = NULL ;
      if (XaLpClientData -> MaLstringList == NULL)
        {
          extern MaClientDataStruct MaFfreeClientData () ;
          MaStringType XaLmessage ;
          sprintf(XaLmessage, "Class %s Does Not Have Any Attribute",
                              XaLpClientData -> MaLclassName) ; 
          if ( XaFisEmptyString(XaLwidget,"",XaLmessage)) ;

          XaLpClientData = MaFfreeClientData (XaLpClientData) ;
          XaFsetRegularCursorFont() ;
          return ;
        }
      else
        {
          MaStringListStruct XaLpStringList = XaLpClientData -> MaLstringList ;
          while (XaLpStringList != NULL)
            {
              strcpy(XaLpStringList -> MaLstringData,
                     XaLpStringList -> MaLlabelType) ;
              XaLpStringList = XaLpStringList -> MaLpNextString ;
            }
        }

    }

    /***************************************************/
    /***************************************************/
    XaLpClientData -> MaLselectionAction = MaSelectionActionViewClassDescription ;
    XaLpClientData -> MaLeditableMode    = False ;

    XaFsetRegularCursorFont() ;

    XaFinstanceDisplayShell(XaLwidget, XaLpClientData) ;

  } /* end   XaFhandleViewClassDescription function */


/*****************************************************************/
/*                      XaFhandleViewClassParent                 */
/*    Function to Handle The Event of the View Class Parent that */
/*  appears in the submenu of View in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleViewClassParent(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleViewClassParent function */
    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    sprintf(XaLquery,"retrieve (parent = padre.relname) \
                      from clase, padre in pg_class, hereda in pg_inherits \
                      where hereda.inhrel = clase.oid \
                            and hereda.inhparent = padre.oid \
                            and clase.relname =  \"%s\"", MaClassName) ;

    MaLpClientData -> MaLstringList = MaFgetStringListExePqCommand(XaLquery) ;

    sprintf(MaLpClientData -> MaLlistLabel, "Parent For Class %s",MaClassName) ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionSetClass ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleViewClassParent function */


/*****************************************************************/
/*                    XaFhandleViewClassChildren                 */
/*    Function to Handle The Event of View Class Children that   */
/*  appears in the submenu of View in main menu bar.             */
/*                                                               */
/*****************************************************************/

void XaFhandleViewClassChildren(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleViewClassChildren function */
    MaStringType XaLquery ;
    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    MaLpClientData = MaFgetPtrClientData() ;

    sprintf(XaLquery,"retrieve (child=hijo.relname) \
                      from  clase, hijo in pg_class, hereda in pg_inherits \
                      where hereda.inhparent = clase.oid \
                            and hereda.inhrel = hijo.oid \
                            and clase.relname =  \"%s\"", MaClassName) ;

    MaLpClientData -> MaLstringList = MaFgetStringListExePqCommand(XaLquery) ;

    sprintf(MaLpClientData -> MaLlistLabel, "Children For Class %s",MaClassName) ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionSetClass ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont() ;

    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleViewClassChildren function */


/*****************************************************************/
/*                  XaFhandleViewClassInstances                  */
/*    Function to Handle The Event of View Class Instances that  */
/*  appears in thesubmenu of View in main menu bar.              */
/*                                                               */
/*****************************************************************/

void XaFhandleViewClassInstances(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleViewClassInstances function */
    extern char *MaFexePqCommand() ;
    MaBufferType XaLquery;
    char *XaLret ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

      sprintf(XaLquery,"retrieve (e.all) from e in %s",MaClassName) ;
      XaLret = MaFexePqCommand(XaLquery) ;
      if (strlen(XaLret) >= (MaMaxBufSize - 2))
        XaLret[MaMaxBufSize - 2] = '\0' ;

      strcpy(XaDisplayBuffer, XaLret) ;
      XaDisplayBuffer[MaMaxBufSize - 2] = '\0' ;

      XaFfillupTextBufferArea(XaDisplayBuffer, XaWorkAreaDisplayText) ;
      XtFree(XaLret) ;

    XaFsetRegularCursorFont() ;

  } /* end   XaFhandleViewClassInstances function */


/*****************************************************************/
/*                  XaFhandleViewClassInstancesByTuple           */
/*    Function to Handle  The Event of  View Class Instances By  */
/*  Tuple that appears in the submenu of View in main menu bar.  */
/*                                                               */
/*****************************************************************/

void XaFhandleViewClassInstancesByTuple(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleViewClassInstancesByTuple function */
    MaClientDataStruct extern MaFgetPtrClientData() ;
    MaClientDataStruct XaLpClientData     ;
                       
    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name Is Empty"))
        return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLlistLabel, "Edit Instance Class") ;
    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;


    /**************************************************/
    /*  Retrieve the Class Attributes and their types */
    /**************************************************/
    if (!XaFsetClassAttributeNameType(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }

    /***************************************************/
    /*  Retrieve the oid of the Instances of the Class */
    /***************************************************/
    if (!XaFsetClassObjectIdsInstances(XaLwidget, XaLpClientData))
      {
        XaFsetRegularCursorFont() ;
        return ;
      }

    /***************************************************/
    /***************************************************/
    XaLpClientData -> MaLselectionAction = MaSelectionActionViewInstance ;
    XaLpClientData -> MaLeditableMode    = False ;

    XaFsetRegularCursorFont() ;

    XaFinstanceDisplayShell(XaLwidget, XaLpClientData) ;

  } /* end   XaFhandleViewClassInstancesByTuple function */


/*****************************************************************/
/*                        XaFhandleHelpView                      */
/*    Function to Handle The Event of Help that  appears in the  */
/*  submenu of View in main menu bar.                            */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpView(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpView function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueView) ;

  } /* end   XaFhandleHelpView function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*        PullDown Utilities Main Menubar Handler Events         */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                    XaFhandleHideCommandWindow                 */
/*    Function to Handle The Event of  Hide Command Window that  */
/*  appears in the submenu of Utilities in main menu bar.        */
/*                                                               */
/*****************************************************************/

void XaFhandleHideCommandWindow()

  { /* begin XaFhandleHideCommandWindow function */

    XtUnmanageChild(XaWorkAreaCommand) ;
    XaString[0] = XmStringCreateSimple("Show Command Window");
    XtUnmanageChild(XaCommandWindowHideButton) ;
    XtManageChild(XaCommandWindowShowButton) ;
    XaShowCommandAreaStatus = MaFALSE ;

  } /* end   XaFhandleHideCommandWindow function */


/*****************************************************************/
/*                    XaFhandleShowCommandWindow                 */
/*    Function to Handle The Event of  Show Command Window that  */
/*  appears in the submenu of Utilities in main menu bar.        */
/*                                                               */
/*****************************************************************/

void XaFhandleShowCommandWindow()

  { /* begin XaFhandleShowCommandWindow function */

    XtManageChild(XaWorkAreaCommand) ;
    XtUnmanageChild(XaCommandWindowShowButton) ;
    XtManageChild(XaCommandWindowHideButton) ;
    XaShowCommandAreaStatus = MaTRUE ;

  } /* end   XaFhandleShowCommandWindow function */


/*****************************************************************/
/*                      XaFhandleResizeWindows                   */
/*    Function to Handle The Event of Resize Windows that appear */
/*  in the submenu of Utilities in main menu bar.                */
/*                                                               */
/*****************************************************************/

void XaFhandleResizeWindows()

  { /* begin XaFhandleResizeWindows function */

    printf("Resizing Window\n") ;
    XtUnmanageChild(XaMainWindow) ;

    XtVaSetValues(XaWorkAreaHeader,
                  XmNheight,      100,
                  NULL) ;

    XaWorkAreaHeaderHeight = 100 ;

    XtVaSetValues(XaTopLevel,
                  XmNheight,      500,
                  XmNwidth,       400,
                  NULL) ;

    XaMainWindowHeight = 500 ;
    XaMainWindowWidth = 400 ;

    XtManageChild(XaWorkAreaHeader) ;
    XtManageChild(XaMainWindow) ;

  } /* end   XaFhandleResizeWindows function */


/*****************************************************************/
/*                      XaFhandleRefreshWindows                  */
/*    Function to Handle The Event  of Refresh Windows that app- */
/*  ears in the submenu of Utilities in main menu bar.           */
/*                                                               */
/*****************************************************************/

void XaFhandleRefreshWindows()

  { /* begin XaFhandleRefreshWindows function */
    char *XaLtext ;

    strcpy(XaCommandBuffer, XaFgetTextBufferArea(XaWorkAreaCommandText)) ;

    XaFupdateXYposition() ;

    if (XaHelpDialogBoxWindow && (XaHelpWindowExistStatus == MaTRUE) )
      {
        XtDestroyWidget(XaHelpDialogBoxWindow) ;
        XaHelpWindowExistStatus = MaFALSE ;
      }

    XtVaSetValues(XaTopLevel,
                  XmNx,           0,
                  XmNy,           0,
                  XmNheight,      1,
                  XmNwidth,       1,
                  NULL) ;

    mainLoop(MaGargc, MaGargv,XaApplication1) ;

  } /* end   XaFhandleRefreshWindows function */


/*****************************************************************/
/*                    XaFhandleClearDisplayArea                  */
/*    Function to Handle The Event  of Help that  appears in the */
/*  submenu of Utilities in main menu bar.                       */
/*                                                               */
/*****************************************************************/

void XaFhandleClearDisplayArea()

  { /* begin XaFhandleClearDisplayArea function */

    strcpy(XaDisplayBuffer, "\0");
    XaFclearTextBufferArea(XaDisplayBuffer,XaWorkAreaDisplayText) ;

  } /* end   XaFhandleClearDisplayArea function */


/*****************************************************************/
/*                  XaFhandleExportClassDefinition               */
/*    Function to Handle The Event  of Export Class Definition   */
/*  that  appears in the submenu of Utilities in main menu bar.  */
/*                                                               */
/*****************************************************************/

void XaFhandleExportClassDefinition(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleExportClassDefinition function */

    MaClientDataStruct XaLpClientData ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLpClientData -> MaLexportFilename,"%s%s%s",
                                                MaProjectPath, 
                                                XaLpClientData -> MaLclassName,
                                                MaClassDefinitionFileExt) ;

    if ((XaLpClientData -> MaLstreamExportFile =
                  fopen(XaLpClientData -> MaLexportFilename,"w")) == NULL)
      {
        sprintf(XaLpClientData -> MaLdialogMessage, 
               "Unable to open Class file %s",
               XaLpClientData -> MaLexportFilename) ;

        XaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;

        XaFsetRegularCursorFont() ;

        XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;
        return ;
      }

    XaLpClientData -> MaLexportInheritMode = MaFALSE ;

    (void) XaFexportClassDefinition(XaLwidget, XaLpClientData) ;

    fclose(XaLpClientData -> MaLstreamExportFile) ;

    XaFsetRegularCursorFont() ;

    XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;

  } /* end   XaFhandleExportClassDefinition function */


/*****************************************************************/
/*                 XaFhandleExportClassDefInherit                */
/*    Function to Handle The Event  of Export Class Def Inherit  */
/*  that  appears in the submenu of Utilities in main menu bar.  */
/*                                                               */
/*****************************************************************/

void XaFhandleExportClassDefInherit(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleExportClassDefInherit function */

    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct XaLpClientData ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLpClientData -> MaLexportFilename,"%s%s%s",
                                                MaProjectPath, 
                                                XaLpClientData -> MaLclassName,
                                                MaClassDefInheritFileExt) ;

    if ((XaLpClientData -> MaLstreamExportFile =
                  fopen(XaLpClientData -> MaLexportFilename,"w")) == NULL)
      {
        sprintf(XaLpClientData -> MaLdialogMessage, 
               "Unable to open Class file %s",
               XaLpClientData -> MaLexportFilename) ;

        XaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;

        XaFsetRegularCursorFont() ;

        XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;
        return ;
      }

    (void) XaFexportClassDefinition(XaLwidget, XaLpClientData) ;

    fclose(XaLpClientData -> MaLstreamExportFile) ;

    XaFsetRegularCursorFont() ;

    XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;

  } /* end   XaFhandleExportClassDefInherit function */


/*****************************************************************/
/*                  XaFhandleExportClassInstances                */
/*    Function to Handle The Event  of Export Class Instances    */
/*  that  appears in the submenu of Utilities in main menu bar.  */
/*                                                               */
/*****************************************************************/

void XaFhandleExportClassInstances(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleExportClassInstances function */

    MaClientDataStruct XaLpClientData ;

    extern MaClientDataStruct MaFfreeClientData () ;
    extern MaClientDataStruct MaFgetPtrClientData() ;


    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLpClientData -> MaLexportFilename,"%s%s%s",
                                    MaProjectPath, 
                                    XaLpClientData -> MaLclassName,
                                    MaClassInstanceFileExt) ;


    /******************************************************/
    /*  Open Class Instance file to write instances to it */
    /******************************************************/
    if ((XaLpClientData -> MaLstreamExportFile =
                fopen(XaLpClientData -> MaLexportFilename, "w")) == NULL)
      {
        sprintf(XaLpClientData -> MaLdialogMessage, 
               "Unable to Open Class Data %s",
               XaLpClientData -> MaLexportFilename) ;

        XaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;

        XaFsetRegularCursorFont() ;

        XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;
        return ;
      }

    (void) XaFexportClassInstances(XaLwidget, XaLpClientData) ;

    fclose(XaLpClientData -> MaLstreamExportFile) ;

    sprintf(XaLpClientData -> MaLdialogMessage, 
            "Class Instances Have Been Exported to File %s Successfully",
            XaLpClientData -> MaLexportFilename) ;

    XaLpClientData -> MaLdialogType = XaDialogNotice ;

    XaFsetRegularCursorFont() ;

    XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;

  } /* end   XaFhandleExportClassInstances function */


/*****************************************************************/
/*                     XaFhandleExportClassTree                  */
/*    Function to Handle  The Event  of Export Class Tree that   */
/*  appears in the submenu of Utilities in main menu bar.        */
/*                                                               */
/*****************************************************************/

void XaFhandleExportClassTree(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleExportClassTree function */

    MaStringListStruct XaLpClassTreeList ;
    MaClientDataStruct XaLpClientData ;

    extern MaStringListStruct MaFfreeStringList  () ;
    extern MaStringListStruct XaFexportClassTree () ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    if (XaFisEmptyString(XaLwidget,MaClassName,"Root Class Name is Empty"))
      return ;

    XaFsetWorkingCursorFont() ;

    XaLpClientData = MaFgetPtrClientData() ;

    strcpy(XaLpClientData -> MaLclassName, MaClassName) ;

    sprintf(XaLpClientData -> MaLexportFilename,"%s%s%s",
                                    MaProjectPath, 
                                    XaLpClientData -> MaLclassName,
                                    MaClassTreeFileExt) ;


    /***********************************************************************/
    /*  Open Class Tree file to write Classes definition & instances to it */
    /***********************************************************************/
    if ((XaLpClientData -> MaLstreamExportFile =
                fopen(XaLpClientData -> MaLexportFilename, "w")) == NULL)
      {
        sprintf(XaLpClientData -> MaLdialogMessage, 
               "Unable to Open Class Data %s",
               XaLpClientData -> MaLexportFilename) ;

        XaLpClientData -> MaLdialogType = XmDIALOG_ERROR ;

        XaFsetRegularCursorFont() ;

        XaFpostDialog(XtParent(XaLwidget) ,XaLpClientData) ;
        return ;
      }

    XaLpClassTreeList =  XaFexportClassTree(XaLwidget,XaLpClientData) ;

    XaLpClassTreeList = MaFfreeStringList(XaLpClassTreeList) ;

    fclose(XaLpClientData -> MaLstreamExportFile) ;

    if (XaFfixReturnCharacterInPostquelFile(XaLwidget, XaLpClientData) == MaTRUE)
      sprintf(XaLpClientData -> MaLdialogMessage, 
              "Class Tree Have Been Exported to File %s Successfully",
               XaLpClientData -> MaLexportFilename) ;
    else
      sprintf(XaLpClientData -> MaLdialogMessage, 
               "Class Tree Have Been Exported to File %s With Error",
               XaLpClientData -> MaLexportFilename) ;

    XaLpClientData -> MaLdialogType = XaDialogNotice ;

    XaFsetRegularCursorFont() ;

    XaFpostDialog(XtParent(XaLwidget), XaLpClientData) ;

  } /* end   XaFhandleExportClassTree function */


/*****************************************************************/
/*               XaFhandleImportSelectedPostquelFile             */
/*    Function to Handle The Event  of Selected Import Postquel  */
/*  File that result from selecting OK in the  Selection Import  */
/*  File that appears in the selection file Popup window.        */
/*                                                               */
/*****************************************************************/

void XaFhandleImportSelectedPostquelFile(XaLfileSelection, XaLclientData, XaLcbs)
  Widget    XaLfileSelection ;
  XtPointer XaLclientData ;
  XmFileSelectionBoxCallbackStruct *XaLcbs ;

  { /* begin XaFhandleImportSelectedPostquelFile function */
#define charset XmSTRING_DEFAULT_CHARSET

    char *XaLfilename ;
    FILE *XaLstreamFilename ;
    MaStringType XaLmessage ;

    if (!XmStringGetLtoR(XaLcbs->value, charset, &XaLfilename))
      {
        (void) (XaFisEmptyString(XaMainMenubar,"","Illegal File Selection")) ;
        return ;
      }

    if (! *XaLfilename)
      {
        (void) (XaFisEmptyString(XaMainMenubar,"","No File Selected.")) ;
        XtFree(XaLfilename) ;
        return ;
      }

    XaFsetWidgetWorkingCursorFont (XaLfileSelection) ;

    XtDestroyWidget(XaLfileSelection) ;

    if ((XaLstreamFilename = fopen(XaLfilename, "r")) == NULL)
      {
        sprintf(XaLmessage,"Filename %s Could Not be Opened to Import it",XaLfilename) ;
        XaFsetRegularCursorFont () ;
        (void) (XaFisEmptyString(XaMainMenubar,"",XaLmessage)) ;
      }
    else
      {
        int XaLindex ;
        int   XaLrecordLength ;
        MaBufferType XaLquery ;

        while(fgets(XaLquery, MaMaxBufSize, XaLstreamFilename) != NULL) 
          {
            XaLrecordLength = strlen(XaLquery) ;
            XaLquery[XaLrecordLength - 3] = '\0' ;
            XaLrecordLength = XaLrecordLength - 3 ;

            for (XaLindex = 0; XaLindex < XaLrecordLength; XaLindex++)
              if (strncmp(&(XaLquery[XaLindex]),"\\n",2) == 0)
                {
                  XaLquery[XaLindex - 1] = ' ' ;
                  XaLindex++ ;
                }

            PQexec("begin") ;
            PQexec(XaLquery) ;
            PQexec("end") ;

          } /* end while fgets */

        sprintf(XaLmessage,"Filename %s Has Been Imported",XaLfilename) ;

        XaFsetRegularCursorFont () ;

        (void) (XaFisEmptyString(XaMainMenubar,"",XaLmessage)) ;

      } /* end else if */

    XtFree(XaLfilename) ;

  } /* end   XaFhandleImportSelectedPostquelFile function */


/*****************************************************************/
/*                   XaFhandleImportPostquelFile                 */
/*    Function to Handle The Event  of Import Postquel File that */
/*  appears in the submenu of Utilities in main menu bar.        */
/*                                                               */
/*****************************************************************/

void XaFhandleImportPostquelFile(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleImportPostquelFile function */
    Widget  XaLfileSelectionBox ;
    void extern XtDestroyWidget() ;

    XaLfileSelectionBox = XmCreateFileSelectionDialog(XtParent(XaLwidget),
                                                      "ImportFileSelection",NULL,0) ;
    XtVaSetValues(XaLfileSelectionBox,
                  XmNwidth,  500,
                  XmNheight, 350,
                  NULL) ;

    XtAddCallback(XaLfileSelectionBox,XmNcancelCallback,
                              XtDestroyWidget , XaLfileSelectionBox) ;

    XtAddCallback(XaLfileSelectionBox,XmNokCallback    ,
                              XaFhandleImportSelectedPostquelFile, NULL) ;

    XtAddCallback(XaLfileSelectionBox,XmNhelpCallback  , 
                              XaFhelpCallback, XaHelpTextValueFileSelectionBox) ;

    XtManageChild(XaLfileSelectionBox) ;

  } /* end   XaFhandleImportPostquelFile function */


/*****************************************************************/
/*                      XaFhandleHelpUtilities                   */
/*    Function to Handle The Event  of Help that  appears in the */
/*  submenu of Utilities in main menu bar.                       */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpUtilities(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpUtilities function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueUtilities) ;

  } /* end   XaFhandleHelpUtilities function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*          PullDown Mosaic Main Menubar Handler Events          */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*               XaFhandleMosaicLaunchMainApplication            */
/*    Function to Handle The Event of Launch Main Application    */
/*  that appears in the submenu of Mosaic in main menu bar.      */
/*                                                               */
/*****************************************************************/

void XaFhandleMosaicLaunchMainApplication(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleMosaicLaunchMainApplication function */
    MaStringType XaLcommand ;
    sprintf(XaLcommand,"%s &",MaMosaicApplicationPath) ;
    system(XaLcommand) ;                 /* This is the system  */
                                         /* command to start    */
                                         /* Mosaic Application. */

    if (XaFisEmptyString(XaLwidget,"",
        "Mosaic Main Application is Launched.")) ;

  } /* end   XaFhandleMosaicLaunchMainApplication function */


/*****************************************************************/
/*               XaFhandleMosaicLaunchSelectedDocument           */
/*    Function to Handle The Event of Launch Selected Document   */
/*  that appears in the submenu of Mosaic in main menu bar.      */
/*                                                               */
/*****************************************************************/

void XaFhandleMosaicLaunchSelectedDocument(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleMosaicLaunchSelectedDocument function */

    extern MaStringListStruct MaFgetStringListExePqCommand() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData = MaFgetPtrClientData() ;

    XaFsetWorkingCursorFont () ;

    MaLpClientData -> MaLstringList =  
              MaFgetStringListExePqCommand("retrieve (Mosaic.subject)") ;

    strcpy(MaLpClientData -> MaLlistLabel, "Mosaic Subject List:") ;

    MaLpClientData -> MaLselectionAction = MaSelectionActionMosaicSelectSubject ;
    MaLpClientData -> MaLselectionMode   = MaSelectionMustMatch ;

    XaFsetRegularCursorFont () ;
    XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

  } /* end   XaFhandleMosaicLaunchSelectedDocument function */


/*****************************************************************/
/*                        XaFhandleHelpMosaic                    */
/*    Function to Handle The Event  of Help that  appears in the */
/*  submenu of Mosaic in main menu bar.                          */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpMosaic(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpMosaic function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueMosaic) ;

  } /* end   XaFhandleHelpMosaic function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*           PullDown Help Main Menubar Handler Events           */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                        XaFhandleHelpHelp_1                    */
/*    Function to Handle The Event of Help_1 that appears in the */
/*  submenu of Help in main menu bar.                            */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpHelp_1(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpHelp_1 function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueHelp1) ;

  } /* end   XaFhandleHelpHelp_1 function */


/*****************************************************************/
/*                        XaFhandleHelpHelp_2                    */
/*    Function to Handle The Event of Help_1 that appears in the */
/*  submenu of Help in main menu bar.                            */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpHelp_2(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpHelp_2 function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueHelp2) ;

  } /* end   XaFhandleHelpHelp_2 function */


/*****************************************************************/
/*                        XaFhandleHelpHelp_3                    */
/*    Function to Handle The Event of Help_1 that appears in the */
/*  submenu of Help in main menu bar.                            */
/*                                                               */
/*****************************************************************/

void XaFhandleHelpHelp_3(XaLwidget)
  Widget  XaLwidget ;

  { /* begin XaFhandleHelpHelp_3 function */

    XaFhelpCallback(XaLwidget,XaHelpTextValueHelp3) ;

  } /* end   XaFhandleHelpHelp_3 function */


/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*                 Work AreaCommand Handler Events               */
/*                                                               */
/*****************************************************************/
/*****************************************************************/

/*****************************************************************/
/*                    XaFhandleWorkAreaCommandClear              */
/*    Function to Handle The Event of Clear that appears in the  */
/*  work area command option window.                             */
/*                                                               */
/*****************************************************************/

void XaFhandleWorkAreaCommandClear(XaLwidget)
  Widget XaLwidget ;

  { /* begin XaFhandleWorkAreaCommandClear function */

    XaFclearTextBufferArea(XaCommandBuffer,XaWorkAreaCommandText) ;

  } /* end   XaFhandleWorkAreaCommandClear function */


/*****************************************************************/
/*                   XaFhandleWorkAreaCommandExecute             */
/*    Function to Handle  The Event of Execute  that appears in  */
/*  the work area command option window.                         */
/*                                                               */
/*****************************************************************/

void XaFhandleWorkAreaCommandExecute(XaLwidget)
  Widget XaLwidget ;

  { /* begin XaFhandleWorkAreaCommandExecute function */
    char         *XaLtext ;
    char         *XaLret ;
    extern char  *MaFexePqCommand() ;

    strcpy(XaCommandBuffer, XaFgetTextBufferArea(XaWorkAreaCommandText)) ;

    {
      int i ;
      MaBufferType XaLquery ;
      FILE   *XaLStreamCommandLogFile ;

      strcpy(XaLquery, XaCommandBuffer) ;

      if (XaLquery[0] != '\0')
        {
          for (i = 0; i < strlen(XaLquery); i++)
            if (XaLquery[i] == '\n')
              XaLquery[i] = ' ' ;
          strcat(XaLquery,"\n") ;
        }

      /************************************************************/
      /* Opening Log file to add the Postquel Commands that is to */
      /* be executed at the end of the Command log file.          */
      /************************************************************/
      if (XaLquery[0] != '\0')
      {
        if ((XaLStreamCommandLogFile = fopen(MaCommandLogFilename,"a")) == NULL)
          {
            printf("Warning !!! Unable to open Log file : %s\n",MaLogFilename) ;
          }
        else 
          {
            fprintf(XaLStreamCommandLogFile,XaLquery) ;
            fclose(XaLStreamCommandLogFile) ;
          }
      }
    }

      XaLret = MaFexePqCommand(XaCommandBuffer) ;
      if (strlen(XaLret) >= (MaMaxBufSize - 2))
        XaLret[MaMaxBufSize - 2] = '\0' ;

      strcpy(XaDisplayBuffer, XaLret) ;
      XaDisplayBuffer[MaMaxBufSize - 2] = '\0' ;
      
      XaFfillupTextBufferArea(XaDisplayBuffer, XaWorkAreaDisplayText) ;
      XtFree(XaLret) ;
      strcpy(XaDisplayBuffer, "\0") ;

  } /* end   XaFhandleWorkAreaCommandExecute function */


/*****************************************************************/
/*                     XaFhandleWorkAreaCommandLog               */
/*    Function to Handle  The Event of Log  that appears in the  */
/*  work area command option window.                             */
/*                                                               */
/*****************************************************************/

void XaFhandleWorkAreaCommandLog(XaLwidget)
  Widget XaLwidget ;

  { /* begin XaFhandleWorkAreaCommandLog function */
    MaStringType       MaLrecord ;
    FILE               *XaLStreamCommandLogFile ;
    MaStringListStruct MaLlogList = NULL ;
    extern MaStringListStruct MaFpointerStringToListAdd() ;
    extern MaClientDataStruct MaFgetPtrClientData() ;

    MaClientDataStruct MaLpClientData = MaFgetPtrClientData() ;

      /************************************************************/
      /* Opening Log file to add the Postquel Commands that is to */
      /* be executed at the end of the Command log file.          */
      /************************************************************/
      if ((XaLStreamCommandLogFile = fopen(MaCommandLogFilename,"r")) == NULL)
        {
          sprintf(MaLrecord,"Sorry Can Not Open The Select File: %s",
                            MaCommandLogFilename) ;
          (void) (XaFisEmptyString(XaLwidget,"",MaLrecord)) ;
        } 
      else
        {
          XaFsetWorkingCursorFont () ;

          while ( 
                 (fgets(MaLrecord,MaMaxRecSize,XaLStreamCommandLogFile) != NULL) 
                )
            {
              int i ;

              for (i = 0; i < strlen(MaLrecord); i++) ;
                if (MaLrecord[i] == '\n')
                  MaLrecord[i] = '\0' ;
              MaLrecord[--i] = '\0' ;
              MaLlogList = MaFpointerStringToListAdd(MaLrecord, MaLlogList) ;
            }
          fclose(XaLStreamCommandLogFile) ;
          strcpy(MaLpClientData -> MaLlistLabel, "Log Command List:") ;

          MaLpClientData -> MaLstringList      = MaLlogList ;
          MaLpClientData -> MaLselectionAction = MaSelectionActionSetLogCommand ;
          MaLpClientData -> MaLselectionMode   = MaAnySelectionOk ;

          XaFsetRegularCursorFont () ;

          XaFhandleSelectionListOption(XaLwidget, MaLpClientData) ;

        }

  } /* end   XaFhandleWorkAreaCommandLog function */


/*****************************************************************/
/*                                                               */
/*                       END OF xahandle.c FILE                  */
/*                                                               */
/*****************************************************************/